
#include <io4433.h>
#include <iomacros.h>
//#include <sig-avr.h>
//#include <interrupt.h>


void waitloop(unsigned int n)
{
	do {
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
	} while (--n);
}


void send(unsigned char c)
{
	outp(c, SPDR);
	waitloop(10);
	outp(0xfd, PORTB);	// ack = L
	waitloop(2);
	outp(0xff, PORTB);	// ack = H
}

int main()
{
	int c, state;

	outp(0x00, DDRC);
	outp(0xff, PORTC);

	outp(0x00, DDRD);
	outp(0xff, PORTD);

	//

	state = 0;

	while (1) {
		if (!state) {
			outp(0x00, DDRB);
			outp(0x00, PORTB);
			outp(0x2c, SPCR);	// disable SPI
			while (~inp(PINB) & 4);
			outp(0x6c, SPCR);	// enable SPI
			outp(0xff, PORTB);
			outp(0x13, DDRB);
			state = 1;
		} else if (inp(SPSR) & 0x80) {
			c = inp(SPDR);
			switch (state) {
			case 1:
				if (c == 0x01) {
					send(0x41);
					state++;
				} else {
					state = 0;
				}
				break;
			case 2:
				if (c == 0x42) {
					send(0x5a);
					state++;
				} else {
					state = 0;
				}
				break;
			case 3:
				c = inp(PINC);
				c = (c << 2) | (c & 1) | 0x06;
				send(c);
				state++;
				break;
			case 4:
				c = inp(PIND);
				send(c);
				state = 1;
				break;
			default:
				state = 0;
				break;
			}
		}
	}
	return 0;
}

